"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RpcClient = void 0;
const axios_1 = __importDefault(require("axios"));
class RpcClient {
    constructor(url, username, password) {
        this.url = url;
        this.username = username;
        this.password = password;
    }
    async call(method, ...params) {
        try {
            const result = await axios_1.default.post(this.url, {
                jsonrpc: "2.0",
                id: 1,
                method,
                params,
            }, {
                auth: {
                    username: this.username,
                    password: this.password,
                },
            });
            return result.data.result;
        }
        catch (e) {
            throw e;
        }
    }
}
exports.RpcClient = RpcClient;
